#include <linux/in.h>
#include <linux/net.h>
#include <linux/types.h>
#include <linux/time.h>
#include <asm/byteorder.h>
#include <asm/errno.h>
#include <asm/fcntl.h>
#include <asm/unistd.h>

static int errno = 0;

#define __NR_CLOSE       __NR_close
static __inline__ _syscall1(int,CLOSE,int,a1)
#define __NR_DUP2        __NR_dup2
static __inline__ _syscall2(int,DUP2,int,a1,int,a2)
#define __NR_EXIT        __NR_exit
static __inline__ _syscall1(int,EXIT,int,a1)
#define __NR_FCNTL       __NR_fcntl
static __inline__ _syscall3(long,FCNTL,int,a1,int,a2,unsigned long,a3)
#define __NR_FORK        __NR_fork
static __inline__ _syscall0(int,FORK)
#define __NR_SELECT      __NR__newselect
static __inline__ _syscall5(int,SELECT,int,a1,fd_set *,a2,fd_set *,a3,fd_set *,a4,struct timeval *,a5)
#define __NR_NANOSLEEP   __NR_nanosleep
static __inline__ _syscall2(int,NANOSLEEP,struct timespec *,a1,struct timespec *,a2)
#define __NR_WAIT4       __NR_wait4
static __inline__ _syscall4(int,WAIT4,int,a1,int *,a2,int,a3,void *,a4)
#define __NR_WRITE       __NR_write
static __inline__ _syscall3(int,WRITE,int,a1,const char *,a2,off_t,a3)
#define __NR_SOCKETCALL __NR_socketcall
static __inline__ _syscall2(int,SOCKETCALL,int,a1,unsigned long *,args)

static unsigned long sargs[3] = { PF_INET, SOCK_STREAM, IPPROTO_TCP };
static unsigned long cargs[3] = { 1, 0, sizeof(struct sockaddr_in) };
static unsigned long gargs[3] = { 0, 0, 0 };

#define SOCKET()      SOCKETCALL(SYS_SOCKET, &sargs[0])
#define CONNECT()     SOCKETCALL(SYS_CONNECT, &cargs[0])
#define GETPEERNAME() SOCKETCALL(SYS_GETPEERNAME, &gargs[0])

static __inline__ void quick_write(int net, int host) {
#define hhex(X) ((i=((X)>>4))>9?i+'a'-10:i+'0')
#define lhex(X) ((i=((X)&15))>9?i+'a'-10:i+'0')
  static unsigned char buf[5] = "0000\n";
  int i;

  buf[0] = hhex(net);
  buf[1] = lhex(net);
  buf[2] = hhex(host);
  buf[3] = lhex(host);
  WRITE(0, (char *)buf, 5);
}

static __inline__ void SLEEP() {
  struct timespec ts;

  ts.tv_sec = 1;
  ts.tv_nsec = 0;
  NANOSLEEP(&ts,&ts);
}

extern void _start() {
#define PORT   25
#define CLASSB 0x825f0000L
  int p, i, l, e;
  struct sockaddr_in saddr;
  fd_set fds, rf, wf;
  struct timeval tm;

  gargs[1] = cargs[1] = (unsigned long)&saddr;
  gargs[2] = (unsigned long)&l;
  tm.tv_sec = 30;
  tm.tv_usec = 0;
  FD_ZERO(&fds);
  for(i=1;i<=254;i++)
    FD_SET(i, &fds);
  for(i=0;i<=255;i++)
    if(i != 1)
      CLOSE(i);
  DUP2(1, 0);
  CLOSE(1);
  saddr.sin_family = AF_INET;
  saddr.sin_port = htons(PORT);
  for(i=0; i<=255; i++) {
    saddr.sin_addr.s_addr = htonl(CLASSB | (i<<8));
repeat_fork:
    if((p = FORK())) {
      if(p == -1) {
        WRITE(0, "XXX1\n", 5);
        while(WAIT4(-1, &p, WNOHANG, NULL) > 0);
        SLEEP();
        goto repeat_fork;
      } else {
        while(WAIT4(-1, &p, WNOHANG, NULL) > 0);
        SLEEP();
      }
    } else {
      break;
    }
  }
  if(i == 256) {
repeat_wait4:
    while(WAIT4(-1, &p, 0, NULL) != -1 && errno != EINTR);
    if(errno != ECHILD) {
      WRITE(0, "XXX2\n", 5);
      SLEEP();
      goto repeat_wait4;
    }
    EXIT(0);
  }
  p = i;
  for(i=1; i<=254; i++, cargs[0]++) {
    saddr.sin_addr.s_addr |= htonl(i);
    if(SOCKET() != i ||
       FCNTL(i, F_SETFL, O_RDWR|O_NONBLOCK) == -1 ||
       CONNECT() != -1 ||
       errno != EINPROGRESS) {
      WRITE(0, "XXX3\n", 5);
      EXIT(0);
    }
    saddr.sin_addr.s_addr &= htonl(~0xffL);
  }
  rf = wf = fds;
  while((e=SELECT(255, &rf, &wf, NULL, &tm)) > 0) {
    for(i=1; e && i<=254; i++) {
      if(FD_ISSET(i, &rf) || FD_ISSET(i, &wf)) {
        e--;
	l = sizeof(saddr);
        FD_CLR(i, &fds);
        gargs[0] = i;
        if(GETPEERNAME() == 0)
          quick_write(p, i);
        CLOSE(i);
      }
    }
    rf = wf = fds;
  }
  if(e != 0)
    WRITE(0, "XXX4\n", 5);
  EXIT(0);
}
